<?php

/*****************************************************************
                   Класс "Полные пути для секций каталога"
                   
Для использования внутри системы требуется внести изменения в системные файлы

2546
$SECTION_PATH = "";
if (strpos($url, "#SECTION_PATH#") !== false && CModule::IncludeModule("it_catalogadds")) {
    $SECTION_ID = ($arrType === "S") ? intval($arr["ID"]) : intval($arr["IBLOCK_SECTION_ID"]);
	$SECTION_PATH = ITCASectionPath::getFullPath(intval($arr["IBLOCK_ID"]), $SECTION_ID);
}
$arReplace[] = $SECTION_PATH;

*****************************************************************/

class ITCASectionPath
{
    function getFullPath($IBLOCK_ID, $SECTION_ID, $createIfEmpty = true)
    {
        global $DB;
        
        static $sectionPathList = array();
        static $iBlockList = array();
        
        $IBLOCK_ID  = (int) $IBLOCK_ID;
        $SECTION_ID = (int) $SECTION_ID;
        
        $sectionPathListKey = $IBLOCK_ID . '_' . $SECTION_ID;
        if (! isset($sectionPathList[$sectionPathListKey])) {
            $sectionPathList[$sectionPathListKey] = "";
            
            do {
                if (! CModule::IncludeModule("iblock")) {
                    break;
                }
                $iBlockRes = CIBlock::GetByID($IBLOCK_ID);
                if(! ($iBlock = $iBlockRes->GetNext())) {
                    break;
                }
                $iBlockList[$IBLOCK_ID] = $iBlock;
                
                if (! in_array($iBlockList[$IBLOCK_ID]['IBLOCK_TYPE_ID'], array('catalog'))) {
                    break;
                }
                
                $strSql = 'SELECT FULL_PATH FROM b_itca_sectionpath '
                        . 'WHERE IBLOCK_ID = ' . $IBLOCK_ID .' AND IBLOCK_SECTION_ID = ' . $SECTION_ID . ' '
                        . 'LIMIT 1';
                
                $res = $DB->Query($strSql, false);
                while ($row = $res->Fetch()) {
                    $sectionPathList[$sectionPathListKey] = $row['FULL_PATH'];
                }
                unset($res);
                
                if ("" === $sectionPathList[$sectionPathListKey] && true === $createIfEmpty) {
                    $arPath = array();
                    
                    $rs = CIBlockSection::GetNavChain($IBLOCK_ID, $SECTION_ID);
                    if (! $rs) {
                        break;
                    }
                    
                    while(($ar = $rs->Fetch())) {
                        $arPath[] = urlencode((! empty($ar['CODE'])) ? $ar['CODE'] : CUtil::translit($ar["NAME"], LANGUAGE_ID));
                    }
                    
                    unset($rs);
                    $sectionPathList[$sectionPathListKey] = trim(implode('/', $arPath), '/');
                    
                    // save ti DB
                    if (! empty($sectionPathList[$sectionPathListKey])) {
                        $arFields = array(
                                'IBLOCK_ID'         => $IBLOCK_ID,
                                'IBLOCK_SECTION_ID' => $SECTION_ID,
                                'FULL_PATH'         => "'" . $sectionPathList[$sectionPathListKey] . "'",
                        );
                        $DB->Insert("b_itca_sectionpath", $arFields);
                    }
                }
                
            } while (false);
        }
        
        return $sectionPathList[$sectionPathListKey];
    }
    function getByFullPath($fullPath) 
    {
        global $DB;
        
        $fullPath = trim($fullPath);
        $strSql = 'SELECT IBLOCK_SECTION_ID FROM b_itca_sectionpath '
                . 'WHERE FULL_PATH = "' . $DB->ForSql(trim($fullPath)) . '" '
                . 'LIMIT 1';
        
        $res = $DB->Query($strSql, false);
        while ($row = $res->Fetch()) {
            return (int) $row['IBLOCK_SECTION_ID'];
        }
        
        return false;
    }
    function parseComponentPath($IBLOCK_ID, $folder404, $arUrlTemplates, &$arVariables)
    {
        global $APPLICATION, $DB;
        
        $IBLOCK_ID  = (int) $IBLOCK_ID;
        $requestURL = $APPLICATION->GetCurPage(true);
        
        if ($folder404 != "/") { 
            $folder404 = "/".Trim($folder404, "/ \t\n\r\0\x0B")."/";
        }
        if(strpos($requestURL, $folder404) !== 0) {
            return false;
        }
          
        $currentPageUrl = trim(substr($requestURL, strlen($folder404)));
        
        $strSql = 'SELECT IBLOCK_SECTION_ID, FULL_PATH FROM b_itca_sectionpath '
                . 'WHERE IBLOCK_ID = ' . $IBLOCK_ID .' AND 1 = LOCATE(FULL_PATH, "' . $DB->ForSql($currentPageUrl) . '") '
                . 'ORDER BY CHAR_LENGTH(FULL_PATH) DESC LIMIT 1';
        
        $res = $DB->Query($strSql, false);
        while ($row = $res->Fetch()) {
            // we have result - find what is it
            foreach ($arUrlTemplates as $pageID => $pageTemplate) {
                if (false !== strpos($pageTemplate, '#')) {
		            
		            $pageTemplate = str_replace('#SECTION_PATH#', '#SECTION_ID#', $pageTemplate);
		            $currentPageUrl = str_replace($row['FULL_PATH'], $row['IBLOCK_SECTION_ID'], $currentPageUrl);
		            
		            if (CComponentEngine::__CheckPath4Template($pageTemplate, $currentPageUrl, $arVariables)) {
				        return $pageID;
		            }
                }
            }
            break;
        }
        
        return false;
    }
    function clearPath($IBLOCK_ID, $SECTION_ID)
    {
        global $DB;
        
        $IBLOCK_ID  = (int) $IBLOCK_ID;
        $SECTION_ID = (int) $SECTION_ID;
        
        $strSql = 'SELECT FULL_PATH FROM b_itca_sectionpath '
                . 'WHERE IBLOCK_ID = ' . $IBLOCK_ID .' AND IBLOCK_SECTION_ID = ' . $SECTION_ID . ' '
                . 'LIMIT 1';
        
        $res = $DB->Query($strSql, false);
        while ($row = $res->Fetch()) {
            
            $strSql = 'DELETE FROM b_itca_sectionpath WHERE IBLOCK_ID = ' . $IBLOCK_ID .' '
                    . 'AND (IBLOCK_SECTION_ID = ' . $SECTION_ID . ' OR 1 = LOCATE("' . $DB->ForSql($row['FULL_PATH']) . '", FULL_PATH))';
            $DB->Query($strSql, false);
        }
    }
    function OnAfterIBlockSectionUpdateHandler(&$arFields)
    {
        ITCASectionPath::clearPath($arFields['IBLOCK_ID'], $arFields['ID']);
    }
}